import com.nttdocomo.ui.*;
import java.io.*;
import java.util.Random;

public final class Card extends IApplication {
	
	public void start() {
		new C();
		C.main();
	}
}

class C extends Canvas {
	
	static final Image[] img = new Image[9];
	static final C _canvas = new C();
	
	//  WFl[^
	static final Random ran = new Random();
	
	//萔Q
	static final int SCENE_INIT  = -1;
	static final int SCENE_TITLE = 0;
	static final int SCENE_GAME  = 1;
	
	//ϐQ
	static int CARD_COUNT = 3;
	
	static int scene = -1;
	static int event = 0;
	
	static int cursolX = 0;
	
	static int turn    = 0;
	static int selectP = -1;
	static int win,lose,draw;
	
	static int[] stockP  = new int[3];
	static int[] stockE  = new int[3];
	static int[] status  = new int[6];
	
	static boolean battle = false;
	
	
	public C() {}
	
	static final void main() {
		Display.setCurrent(_canvas);
		
		try {
			for (int i=0;i<9;i++) {
				MediaImage mi = MediaManager.getImage("resource:///"+ i +".gif");
				mi.use();
				img[i] = mi.getImage();
			}
		} catch (IOException e) {}

		scene = SCENE_TITLE;
		_canvas.setSoftLabel(0,"I");

		for (;;) {
			switch(scene) {
				case SCENE_TITLE:
					if (event == Display.KEY_SELECT) {
						stockP = cardSet(15);
						stockE = cardSet(15);
						turn = 1;
						scene = SCENE_GAME;
					}
					break;
					
				case SCENE_GAME:
					int add = 0;
					switch(event) {
						case Display.KEY_LEFT:
							add = CARD_COUNT - 1;
							break;
							
						case Display.KEY_RIGHT:
							add = 1;
							break;
							
						case Display.KEY_SELECT:
							if (turn == 4) {
								break;
							}
							if (!battle) {
								battle = true;
								if (status[cursolX] == 0) {
									if (stockP[cursolX] > stockE[turn-1]) {
										//
										status[cursolX] = 1;
										status[turn + 2] = 2;
										win++;
									} else if (stockP[cursolX] < stockE[turn-1]) {
										//
										status[cursolX] = 2;
										status[turn + 2] = 1;
										lose++;
									} else {
										//
										status[cursolX] = 3;
										status[turn + 2] = 3;
										draw++;
									}
									turn++;
									if (turn == 4) {
										_canvas.setSoftLabel(1, "");
									}
								}
							}
							break;
						
						case Display.KEY_SOFT2:
							if (turn == 4) {
								cursolX = 0;
								turn    = 0;
								selectP = -1;
								win = lose = draw = 0;
			
								for (int i=0;i<3;i++) {
									stockP[i] = 0;
									stockE[i] = 0;
								}
								for (int i=0;i<6;i++) {
									status[i] = 0;
								}
								_canvas.setSoftLabel(0,"I");
								_canvas.setSoftLabel(1,"");
								scene = SCENE_TITLE;
							}
							break;
					}
					if (CARD_COUNT > 0) {
						cursolX += add;
						cursolX %= CARD_COUNT;
					}
					break;
			}
			event = 0;
			if (battle) {
				battle = false;
			}
			repaint2();
		}

	}
	
	static void repaint2() {
		_canvas.paint(_canvas.getGraphics());
	}
	
	public void paint(Graphics g) {
		synchronized (this) {
			g.lock();
	
			g.clearRect(0, 0, getWidth(), getHeight());
			g.setColor(0);
	
			switch(scene) {
				case SCENE_INIT:
					g.drawString("Nc", 60, 120);
					break;
				
				case SCENE_TITLE:
					g.drawString("nl", 80, 120);
					g.drawString("{^Ă", 30, 140);
					break;
				
				case SCENE_GAME:
					g.fillRect(55+(cursolX*60), 195, 60, 40);
					
					if (turn == 4) {
						g.drawString(win+""+lose+"s"+draw+"", 80, 140);
						g.drawString("\tgL[2Ń^Cgɖ߂", 20, 155);
					}
					
					for (int i=0;i<3;i++) {
						//̃J[h\iEj
						g.drawImage(img[stockP[i]-1], 60+(i%3*60), 200);
						//G̃J[h\ij
						g.drawImage(img[stockE[i]-1], 10+(i%3*60), 20);
						
						//J[h̏s\
						if (status[i] == 1) {
							g.drawString("Win", 80+(i%3*60), 190);
						} else if (status[i] == 2) {
							g.drawString("Lose", 80+(i%3*60), 190);
						} else if (status[i] == 3) {
							g.drawString("Draw", 80+(i%3*60), 190);
						}
						if (status[i+3] == 1) {
							g.drawString("Win", 30+(i%3*60), 85);
						} else if (status[i+3] == 2) {
							g.drawString("Lose", 30+(i%3*60), 85);
						} else if (status[i+3] == 3) {
							g.drawString("Draw", 30+(i%3*60), 85);
						}
						
						//܂JĂȂG̃J[hhԂ
						if (turn-2 < i){
							g.fillRect(10+(i%3*60), 20, 50, 30);
						}
					}
					break;
			}
	
			g.unlock(true);
		}
	}
	
	/*
	 * L[/ƁA
	 * processEventĂ΂
	 * 
	 * L[ꂽɂ́ADisplay.KEY_PRESSED_EVENTA
	 * L[ꂽɂ́ADisplay.KEY_RELEASED_EVENT
	 * paramɑ
	 */
	public void processEvent(int param, int key) {
		if (param == Display.KEY_PRESSED_EVENT) {
			event = key;
		}
	}
	
	/**
	 * cardSet
	 * 3̍vl傤ǈ̒lɂȂ悤
	 * _3̐lԂ
	 * @param  int    3̍vl
	 * @return int[]  _3̐l
	 */
	private static int[] cardSet(int max) {
		int[] array = new int[3];
		array[0] = ranRange(1, 9);
		int start = max-9-array[0];
		int end   = max-1-array[0];
		if (start < 1) {
			start = 1;
		}
		if (end > 9) {
			end = 9;
		}
		array[1] = ranRange(start, end);
		array[2] = max - array[0] - array[1];
		return array;
	}
	
	/**
	 * ranRange
	 * startend܂ł̊Ԃ̗Ԃ
	 * 
	 * @param  int    start ŏl
	 * @param  int    end   ől
	 * @return int    l
	 */
	private static int ranRange(int start, int end) {
		int retrand;
		int range  = (end - start) + 1;
		do {
			retrand = Math.abs(ran.nextInt() % range);
		} while (retrand == 0);
		return retrand + start -1;
	}
	
}